
def loadClusters(filename):

    f = open(filename)

    # read header
    f.readline()

    clusters = {}
    
    for r in f.readlines():
        data = r.split()
        if clusters.has_key(data[0]):
            clusters[data[0]].append(data[2])
        else:
            clusters[data[0]] = [data[2]]

    return clusters


def numMIRNAs(elements):

    rbp = 0
    miRNA = 0

    for e in elements:
        if e[:3] == "hsa":
            miRNA += 1
       
    return miRNA


def miRNAStatistics(clusters):

    miRNAs = {}
    
    for (id,elements) in clusters.items():
        miRNA = numMIRNAs(elements)
        if miRNAs.has_key(miRNA):
            miRNAs[miRNA] += 1
        else:
            miRNAs[miRNA] = 1

    return miRNAs


def printStatistics(stats):

    data = stats.items()
    data.sort()
    print " ".join(["%d => %d" % (size,freq) for (size,freq) in data])


def computeMIRNAStatistics(clusterfile):
    
    clusters = loadClusters(clusterfile)
    miRNAs = miRNAStatistics(clusters)
    printStatistics(miRNAs)
