import math

def loadPolysomes(filename):

    f = open(filename)

    # read header
    f.readline()
    f.readline()

    polysomes = {}
    coordinates = []
                
    for r in f.readlines():
        if "=" in r or "ribosomes" in r:
            continue
        if r[:5] == "image":
            polysome = r.split()[1]
            polysomes[polysome] = coordinates
            coordinates = []
        else:
            data = [float(d) for d in r.split()]
            coordinates.append(data)

    return polysomes

def minDistances(points):

    distances = [0] * len(points)
    
    for i in range(len(points)):
        for j in range(len(points)):
            if i == j:
                continue
            [x1,y1,z1] = points[i]
            [x2,y2,z2] = points[j]
            dist = math.sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2)+(z1-z2)*(z1-z2))
            if distances[i] == 0 or distances[i] > dist:
                distances[i] = dist

    return distances

def printDistances(distances):
    distances.sort()
    print "\n".join([str(d) for d in distances])
    

def computeMinDistances(filename):
    polysomes = loadPolysomes(filename)
    for (name,ribosomes) in polysomes.items():
        distances = minDistances(ribosomes)
        print name
        printDistances(distances)
