
def loadAlignments(filename):

    f=open(filename)
    alignments={}    
    for row in f:
        if row[0] == '#':
            continue
        data = row.split()
        alignments[data[0]] = data[1]
    return alignments


def computeMatchDelSequence(alignment):

    match_del_seq = [] 
    for p in alignment:
        if p.isupper():
            match_del_seq.append(1.)
        elif p == '-':
            match_del_seq.append(0.)
    return match_del_seq


def computeMatchDelSequences(alignment_map):

    mean_seq = []
    
    for alignment in alignment_map.values():
        seq = computeMatchDelSequence(alignment)
        if not mean_seq:
            mean_seq = seq
        else:
            for i in range(len(mean_seq)):
                mean_seq[i] += seq[i]

    for i in range(len(mean_seq)):
        mean_seq[i] /= len(alignment_map)

    return mean_seq


def printConservations(conservations):
    for p in range(len(conservations)):
        print(p,conservations[p])
        
def averageMatchConservation(filename):
    alignments = loadAlignments(filename)
    conservations = computeMatchDelSequences(alignments)
    printConservations(conservations)

averageMatchConservation('alignments')
