def loadMBS(filename):

    f = open(filename)
    mbs={}

    protein=""
    positions,sites=[],[]
    
    for row in f:
        data = row.split()        
        if data[0] == "chainId:":
            if protein:
                mbs[protein]=(positions,sites)
            protein=data[1]
            positions,sites=[],[]
        elif data[0] == "chPositions:":
            positions = data[1:]
        elif data[0][:8] == "chInSite":
            sites.append(data[1:])
            
    if protein:
        mbs[protein]=(positions,sites)

    return mbs


def printSites(protein,positions,sites):

    print(protein)
    for site in sites:
        for p in site:
            print(positions[int(p)] + " "),
        print

def printSites4Protein(mbs):

    for (protein,(positions,sites)) in mbs.items():
        printSites(protein,positions,sites)
        print

def printMetalBindingSites(filename):

    mbs=loadMBS(filename)
    printSites4Protein(mbs)
